﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace InfraSample
{
    public partial class Form1 : Form
    {
        UltraGrid grid;
        int _currentRowIndex;
        public Form1()
        {
            InitializeComponent();
            this.Load += Form1_Load;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            CreateGrid();
        }

        private void CreateGrid()
        {
            Button t1 = new Button();
            t1.Text = "Reload";
            t1.Click += T1_Click;
            t1.Size = new System.Drawing.Size(100, 22);
            t1.Location = new System.Drawing.Point(380, 100);

            //t1.Dock = DockStyle.Top;
            this.Controls.Add(t1);
            grid = new UltraGrid();
            //grid.Dock = DockStyle.Left;
            grid.Size = new System.Drawing.Size(325, 350);
            grid.Location = new System.Drawing.Point(10, 2);
            this.Controls.Add(grid);

            this.grid.InitializeRow += Grid_InitializeRow;
            this.grid.InitializeLayout += Grid_InitializeLayout;
            this.grid.DoubleClickRow += Grid_DoubleClickRow;
            grid.AfterSelectChange += Grid_AfterSelectChange;
            grid.ClickCell += Grid_ClickCell;
            SetData();
        }

        private void T1_Click(object sender, EventArgs e)
        {
            _currentRowIndex = grid.Selected.Rows[0].Index;
            SetData();
            NavigateInGrid("");
        }

        private void Grid_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Override.SelectTypeRow = SelectType.Default;
            e.Layout.Override.SelectTypeCol = SelectType.None;
            e.Layout.Override.SelectTypeCell = SelectType.None;
            e.Layout.Override.AllowDelete = DefaultableBoolean.False;
            e.Layout.Override.AllowUpdate = DefaultableBoolean.False;
            e.Layout.Override.CellClickAction = CellClickAction.RowSelect;
            e.Layout.Bands[0].Override.RowSelectors = DefaultableBoolean.False;
            e.Layout.Bands[0].Override.AllowUpdate = DefaultableBoolean.False;
            e.Layout.Override.HeaderClickAction = HeaderClickAction.SortMulti;
            e.Layout.Override.RowAppearance.FontData.Name = "Tahoma";
            e.Layout.Override.RowAppearance.FontData.SizeInPoints = 8f;
            e.Layout.Override.CellAppearance.BorderAlpha = Alpha.Default;
            // e.Layout.Override.CellAppearance.BorderColor = Color.Black;
            e.Layout.Override.RowAppearance.BorderAlpha = Alpha.Transparent;
            e.Layout.Override.BorderStyleCell = UIElementBorderStyle.Default;
            e.Layout.Override.BorderStyleRow = UIElementBorderStyle.Default;
            e.Layout.Bands[0].Override.HeaderAppearance.TextHAlign = HAlign.Left;
        }

        private void Grid_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            //throw new NotImplementedException();
        }
        private void Grid_DoubleClickRow(object sender, DoubleClickRowEventArgs e)
        {
            _currentRowIndex = grid.Selected.Rows[0].Index;
            SetData();
            NavigateInGrid("");
        }

        private void Grid_AfterSelectChange(object sender, AfterSelectChangeEventArgs e)
        {
            if (grid.Selected.Rows.Count > 1)
            {
                //foreach (UltraGridRow item in uGridPatientTask.Selected.Rows.Cast<UltraGridRow>().Where(p => !(bool)p.Cells["Tick"].Value).ToList())
                //{
                //    if (item.Cells["TaskDetails"].Value.ToString() != "Confidential")
                //    {
                //        item.Cells["Tick"].Value = true;
                //    }

                //}

                if (e.Type == typeof(UltraGridRow))
                {
                    foreach (UltraGridRow row in this.grid.Selected.Rows)
                    {
                        row.Cells["Tick"].Value = true; // Or some value appropriate to your scenario
                    }

                    this.grid.UpdateData();
                    grid.Update();
                }
            }
        }

        private void Grid_ClickCell(object sender, ClickCellEventArgs e)
        {
            if (grid != null && grid.Rows.Count > 0 && grid.Selected.Rows.Count > 0)
            {
                if (grid.Selected.Rows.Count == 1)
                {
                    if ((bool)grid.Selected.Rows[0].Cells["TICK"].Value == true)
                        grid.Selected.Rows[0].Cells["TICK"].Value = false;

                    else
                        grid.Selected.Rows[0].Cells["TICK"].Value = true;
                }
                grid.Update();
            }
        }

        public void SetData()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("Tick", typeof(bool));
            dt.Columns.Add("Details", typeof(string));
            dt.Columns.Add("type", typeof(string));

            for (int i = 0; i < 50; i++)
            {
               var dr= dt.NewRow();
                dr[0] = false;
                dr[1] = "Row" + i;
                dr[2] = "type" + i;
                dt.Rows.Add(dr);
            }
            grid.SuspendRowSynchronization();
            grid.DataSource = dt;
            grid.DataBind();
            grid.ResumeRowSynchronization();
            NavigateInGrid("");
        }

        private void NavigateInGrid(string SelectedIDValue)
        {
            grid.Selected.Rows.Clear();
            //grid.ActiveRow = null;
            grid.Rows[_currentRowIndex].Activate();
            grid.Rows[_currentRowIndex].Selected = true;
            //uGridPatientTask.Rows[_currentRowIndex].Cells[1].Selected = true;
            //uGridPatientTask.Rows[_currentRowIndex].Cells[1].Selected = true;
            //uGridPatientTask.Rows[_currentRowIndex].Cells[1].Activate();
            grid.Select();
        }
    }
}
